package util

import (
	"fmt"
	"git.168cad.top/zhengqiuyun/rym-util/exception"
	"github.com/gin-gonic/gin"
	"strconv"
)

func ParamInt64(c *gin.Context, key string) int64 {
	return int64(ParamInt(c, key))
}

func ParamInt32(c *gin.Context, key string) int32 {
	return int32(ParamInt(c, key))
}

func ParamInt16(c *gin.Context, key string) int16 {
	return int16(ParamInt(c, key))
}

func ParamInt8(c *gin.Context, key string) int8 {
	return int8(ParamInt(c, key))
}

func ParamUint64(c *gin.Context, key string) uint64 {
	return uint64(ParamInt(c, key))
}

func ParamUint32(c *gin.Context, key string) uint32 {
	return uint32(ParamInt(c, key))
}

func ParamUint16(c *gin.Context, key string) uint16 {
	return uint16(ParamInt(c, key))
}

func ParamUint8(c *gin.Context, key string) uint8 {
	return uint8(ParamInt(c, key))
}

func ParamInt(c *gin.Context, key string) int {
	v := c.Query(key)
	if v == "" {
		return 0
	}
	i, err := strconv.Atoi(v)
	if err != nil {
		exception.ThrowsErrS("PARAMS_ERR", "请传入正确的数字")
	}
	return i
}

func ParamFloat64(c *gin.Context, key string) float64 {
	v := c.Query(key)
	if v == "" {
		return 0
	}
	i, err := strconv.ParseFloat(v, 2)
	if err != nil {
		exception.ThrowsErrS("PARAMS_ERR", "请传入正确的数字")
	}
	return i
}

func ParamFloat32(c *gin.Context, key string) float32 {
	return float32(ParamFloat64(c, key))
}

func ParamFloat64B(c *gin.Context, key string, bitSize int) float64 {
	v := c.Query(key)
	if v == "" {
		return 0
	}
	i, err := strconv.ParseFloat(v, bitSize)
	if err != nil {
		exception.ThrowsErrS("PARAMS_ERR", "请传入正确的数字")
	}
	return i
}

func ParamFloat32B(c *gin.Context, key string, bitSize int) float32 {
	return float32(ParamFloat64B(c, key, bitSize))
}

func Param(c *gin.Context, key string) string {
	v, ok := c.GetQuery(key)
	if !ok || v == "" {
		exception.ThrowsErrS("PARAMS_ERR", fmt.Sprintf("%s不能为空", key))
	}
	return v
}

func ParamB(c *gin.Context, key string) string {
	v := c.Query(key)
	return v
}
